#pragma once

// FAW`FbNƁAFAWPreview.aufg1aacfR[h by ru
//
// @̃\[XɂāAru͒쌠咣܂̂ŁApς͂RɁB
// KȃTv
/*
	short *audiop = f[^
	int samples = ɓĂshorť

	short wav[2048];

	CFAW cfaw;
	int j = cfaw.findFAW(audiop, samples);
	if (j != -1) {
		cfaw.decodeFAW(audiop + j, samples - j, wav);

		// wav1024Tv~2chPCMf[^Ă̂łD
	}
*/
class CFAW {
	bool is_half;

	bool load_failed;
	HMODULE _h;

	typedef int (__stdcall *ExtractDecode1FAW)(const short *in, int samples, short *out, bool is_half);
	ExtractDecode1FAW _ExtractDecode1FAW;

	bool load() {
		if (_ExtractDecode1FAW == NULL && load_failed == false) {
			_h = LoadLibrary("FAWPreview.auf");
			if (_h == NULL) {
				load_failed = true;
				return false;
			}
			_ExtractDecode1FAW = (ExtractDecode1FAW)GetProcAddress(_h, "ExtractDecode1FAW");
			if (_ExtractDecode1FAW == NULL) {
				FreeLibrary(_h);
				_h = NULL;
				load_failed = true;
				return false;
			}
			return true;
		}
		return true;
	}
public:
	CFAW() : _h(NULL), _ExtractDecode1FAW(NULL), load_failed(false), is_half(false) { }
	
	~CFAW() {
		if (_h) {
			FreeLibrary(_h);
		}
	}

	bool isLoadFailed(void) {
		return load_failed;
	}

	//   FAWJnn_TB1/1ł1/2łB
	//   1/2FAW΁Aȍ~͂ꂵTȂB
	// in: get_audio()œf[^
	// samples: get_audio() * ch
	// ߂lFFAWJnʒũCfbNXBȂ-1
	int findFAW(short *in, int samples) {
		// search for 72 F8 1F 4E 07 01 00 00
		static unsigned char faw11[] = {0x72, 0xF8, 0x1F, 0x4E, 0x07, 0x01, 0x00, 0x00};
		if (is_half == false) {
			for (int j=0; j<samples - 30; ++j) {
				if (memcmp(in+j, faw11, sizeof(faw11)) == 0) {
					return j;
				}
			}
		}

		// search for 00 F2 00 78 00 9F 00 CE 00 87 00 81 00 80 00 80
		static unsigned char faw12[] = {0x00, 0xF2, 0x00, 0x78, 0x00, 0x9F, 0x00, 0xCE,
										0x00, 0x87, 0x00, 0x81, 0x00, 0x80, 0x00, 0x80};

		for (int j=0; j<samples - 30; ++j) {
			if (memcmp(in+j, faw12, sizeof(faw12)) == 0) {
				is_half = true;
				return j;
			}
		}

		return -1;
	}

	// FAWPreview.aufgFAWf[^1𒊏ofR[h
	// in: FAWJnʒũ|C^BfindFAWɓnin + findFAW̖߂l
	// samples: inɂf[^shortZł̃TCY
	// out: fR[hʂobt@(16bit, 2ch1024Tv)
	//     i1024sample * 2byte * 2ch = 4096oCgKvj
	int decodeFAW(const short *in, int samples, short *out){
		if (load()) {
			return _ExtractDecode1FAW(in, samples, out, is_half);
		}
		return 0;
	}
};